//+------------------------------------------------------------------+
//|                                           Waddah_Attar_Trend.mq4 |
//|                              Copyright  2007, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2007, Eng. Waddah Attar"
#property  link      "waddahattar@hotmail.com"
//----
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_width1  2
#property  indicator_width2  2

extern ENUM_TIMEFRAMES TimeFrame       = PERIOD_CURRENT;
extern bool            alertsOn        = true;
extern bool            alertsOnCurrent = false;
extern bool            alertsMessage   = true;
extern bool            alertsSound     = false;
extern bool            alertsNotify    = false;
extern bool            alertsEmail     = false;
extern string          soundFile       = "alert2.wav";

//----
double ind_buffer1[];
double ind_buffer2[];
string indicatorFileName;
bool   returnBars;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0, ind_buffer1); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1, ind_buffer2); SetIndexStyle(1, DRAW_HISTOGRAM);
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame==-99);
   TimeFrame         = MathMax(TimeFrame,_Period);   
   IndicatorShortName(timeFrameToString(TimeFrame)+" Waddah Attar Trend");
   Comment("copyright waddahwttar@hotmail.com");
return(0);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
{
   Comment("");
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);
           if (returnBars)  { ind_buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
     for(i = limit - 1; i >= 0; i--)
     {
        double Trend = (iMACD(NULL,0,20,40,9,PRICE_CLOSE,MODE_MAIN,i) - iMACD(NULL,0,20,40,9,PRICE_CLOSE,MODE_MAIN,i+1)) / Point;
        double Explo = (iBands(NULL,0,20,2,0,PRICE_CLOSE,MODE_UPPER,i) - iBands(NULL,0,20,2,0,PRICE_CLOSE,MODE_LOWER,i)) / Point;
        ind_buffer1[i] = 0;
        ind_buffer2[i] = 0;
        double val=Trend*Explo;
        if(val >= 0) ind_buffer1[i] = val;
        if(val < 0)  ind_buffer2[i] = val;
     }
     
     //
     //
     //
     //
     //
    
     if (alertsOn)
     {
       if (alertsOnCurrent)
            int whichBar = 0;
       else     whichBar = 1;  
      
       //
       //
       //
       //
       //
      
       if (ind_buffer1[whichBar+1] == 0 && ind_buffer1[whichBar] != 0) doAlert(whichBar,"up");
       if (ind_buffer2[whichBar+1] == 0 && ind_buffer2[whichBar] != 0) doAlert(whichBar,"down");
     }         
     return(0);
    }
    
    //
    //
    //
    //
    //
    
    limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
    for (i=limit;i>=0;i--)
    {
       int y = iBarShift(NULL,TimeFrame,Time[i]);
          ind_buffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,0,y);
          ind_buffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,1,y);     
    } 
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}


//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

           message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Waddah_Attar_Trend ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Waddah_Attar_Trend "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}





